using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Ports;
using System.Text;
using System.Threading;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Utils;
using MSCommLib;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacLotPlayMode;
using ChuPiao.Common.Communication.GtdJson.Packs;
using ChuPiao.Common.Communication.GtdJson;
using ChuPiao.Common.Communication.GtdJson.Items;

namespace ChuPiao.AutoPrint.Machine.TjJingCaiV1
{
    /// <summary>
    /// ӡģ
    /// </summary>
    public class VirtualPrinter : BaseVirtualPrinter
    {
        //private MSCommClass MSPrinterComm;
        //private EventWaitHandle MSCommMutex;
        ////public event HandleCommEvDSRDelegate OnCommEventDSR;
        public VirtualPrinter(string port, int portBps)
        {
            this.Status = VirtualPrinterStatus.Stopped;
            this.Port = port;
            this.PortBps = portBps;

            //this.ComSettings = string.Format("{0},N,8,1", portBps);
        }
        #region Overrides of BaseVirtualPrinter
        //̿߳
        private Thread _workThread;

        /// <summary>
        /// ʼ
        /// </summary>
        public override void Initialize()
        {
            //this.MSPrinterComm = new MSCommClass();
            //this.MSCommMutex = new ManualResetEvent(true);
            //MSPrinterComm.OnComm += new DMSCommEvents_OnCommEventHandler(MSPrinterComm_OnComm);

            PrinterPort = new SerialPort(Port, PortBps, Parity.None);
            PrinterPort.RtsEnable = true;
            PrinterPort.DtrEnable = true;

            Log.Info("ӡʼɣ");
        }

        //void MSPrinterComm_OnComm()
        //{
        //    switch (MSPrinterComm.CommEvent)
        //    {
        //        case 2:
        //            ReceiveDataFromComm();
        //            break;
        //        case 4:
        //            break;
        //        case 1001:
        //            break;
        //    }
        //}
        //private void ReceiveDataFromComm()
        //{
        //    MSCommMutex.WaitOne();
        //    MSCommMutex.Reset();
        //    byte[] readBytes = (byte[])MSPrinterComm.Input;
        //    while (readBytes.Length > 0)
        //    {
        //        if (AlldataStream != null)
        //        {
        //            AlldataStream.Write(readBytes, 0, readBytes.Length);
        //            AlldataStream.Flush();
        //        }
        //        _receivedBuffer.AddRange(readBytes);
        //        string tmpStr = HexString.ByteToString(readBytes) + " ";
        //        _receivedStringBuffer.Append(tmpStr);
        //        Log.Debug(string.Concat("ӲƱֽ", readBytes.Length));
        //        //Log.Debug(string.Concat("ӲƱյݣ", tmpStr, "ֽ", readBytes.Length, " ַܳȣ", _receivedStringBuffer.Length));
        //        readBytes = (byte[])MSPrinterComm.Input;
        //        //Thread.Sleep(5);
        //    }
        //    bool isreply = false;
        //    string strReceived = _receivedStringBuffer.ToString();
        //    if (strReceived.EndsWith("10 04 01 10 04 02 10 04 03 10 04 04 "))
        //    {
        //        isreply = true;
        //        strReceived = "";
        //        _receivedBuffer.Clear();
        //        _receivedStringBuffer.Remove(0, _receivedStringBuffer.Length);
        //    }
        //    //if(strReceived.StartsWith("10 04 01 10 04 02 10 04 03 10 04 04"))
        //    //{
        //    //    isreply = true;
        //    //    _receivedBuffer.RemoveRange(0, 12);
        //    //    _receivedStringBuffer.Remove(0, 36);
        //    //}
        //    //if (strReceived.StartsWith("00 1B 40 1D 50 CB CB 1B 23 2A 0A 00 10 04 01 10 04 02 10 04 03 10 04 04"))
        //    //{
        //    //    isreply = true;
        //    //    _receivedBuffer.RemoveRange(0, 24);
        //    //    _receivedStringBuffer.Remove(0, 72);
        //    //}
        //    //if (strReceived.StartsWith("00 1B 40 1D 50 CB CB 10 04 01 10 04 02 10 04 03 10 04 04"))
        //    //{
        //    //    isreply = true;
        //    //    _receivedBuffer.RemoveRange(0, 19);
        //    //    _receivedStringBuffer.Remove(0, 57);
        //    //}
        //    //if (strReceived.StartsWith("1B 40 1D 50 CB CB 10 04 01 10 04 02 10 04 03 10 04 04"))
        //    //{
        //    //    isreply = true;
        //    //    _receivedBuffer.RemoveRange(0, 18);
        //    //    _receivedStringBuffer.Remove(0, 54);
        //    //}
        //    //if (strReceived.StartsWith("1D 50 CB CB 10 04 01 10 04 02 10 04 03 10 04 04"))
        //    //{
        //    //    isreply = true;
        //    //    _receivedBuffer.RemoveRange(0, 16);
        //    //    _receivedStringBuffer.Remove(0, 48);
        //    //}
        //    if (strReceived.StartsWith("1D 4C 40 00 1D 57 00 03"))
        //    {
        //        isreply = true;
        //        _receivedBuffer.RemoveRange(0, 8);
        //        _receivedStringBuffer.Remove(0, 24);
        //    }

        //    if (isreply)
        //    {
        //        Reply("16 12 12 12");
        //    }
        //    else
        //    {
        //        //ȡƱݣжǷյһƱ
        //        strReceived = _receivedStringBuffer.ToString();
        //        //if (!_oneTicketReceived && strReceived.IndexOf(EndString) != -1)
        //        if (!_oneTicketReceived && strReceived.Length > 900 && strReceived.IndexOf(EndString, 200) != -1)
        //        {
        //            Log.Info(string.Concat("ӲƱյһƱֽ", _receivedBuffer.Count, "ַܳȣ", strReceived.Length));
        //            _oneTicketReceived = true;
        //            SaveLastFile(_receivedBuffer.ToArray());
        //            try
        //            {
        //                if (MachineInfo.M_AllowPaperout)
        //                {
        //                    //this.PrinterClient.AddBytes(_receivedBuffer.ToArray());
        //                }
        //            }
        //            catch (Exception exception)
        //            {
        //                Log.Info(string.Concat("ӡ", exception.ToString()));
        //            }

        //            oneTicketData = new byte[_receivedBuffer.Count];
        //            _receivedBuffer.CopyTo(oneTicketData);
        //            ClearBufferAfterOneTicket();
        //        }
        //    }
        //    MSCommMutex.Set();

        //}
        //private void Reply(string sendhex)
        //{
        //    MSPrinterComm.Output = HexString.StringToByte(sendhex);
        //    Log.Info(string.Concat("ظ", sendhex));
        //}

        /// <summary>
        /// 
        /// </summary>
        public override void Start()
        {
            try
            {
                if (Status != VirtualPrinterStatus.Stopped)
                {
                    return;
                }
                if (PrinterPort == null)
                {
                    PrinterPort = new SerialPort(Port, PortBps, Parity.None);
                }
                if (!PrinterPort.IsOpen)
                {
                    PrinterPort.Open();

                    int writeByteInt = PrinterPort.BytesToWrite;
                    if (writeByteInt > 0)
                    {
                        //շݵĻ
                        PrinterPort.DiscardOutBuffer();
                        Log.Info("PrinterPort.OpenдSize" + PrinterPort.WriteBufferSize.ToString() + "ֽ" + writeByteInt.ToString() + "DiscardOutBuffer" + PrinterPort.BytesToWrite.ToString());
                    }
                    else
                    {
                        Log.Info("PrinterPort.OpenдSize" + PrinterPort.WriteBufferSize.ToString() + "ֽ0");
                    }
                }
                //if (AlldataStream == null)
                //{
                //    string filePath = AlldataFilePath;
                //    AlldataStream = new FileStream(filePath, FileMode.Append, FileAccess.Write);
                //}
                //OpenPrinterComm();
                _workThread = new Thread(new ThreadStart(DoTask));
                Status = VirtualPrinterStatus.Running;
                _workThread.Start();

                Log.Info(string.Concat("ӡɹ˿ںţ", Port, " ", PortBps));
            }
            catch (Exception exception)
            {
                Log.Warn(string.Concat("ӡ쳣Ϣ", exception));
                Log.Warn("ʾʱûбſʼƱ");
            }
        }

        /// <summary>
        /// ֹͣ
        /// </summary>
        public override void Stop()
        {
            Status = VirtualPrinterStatus.Stopped;
            //ClosePrinterComm();

            PrinterPort.Close();
            //PrinterPort = null;

            //if (AlldataStream != null)
            //{
            //    AlldataStream.Close();
            //    AlldataStream.Dispose();
            //}
            
            Log.Info("ӡֹͣ");
        }

        //private string _ComSettings = "19200,N,8,1";
        ///// <summary>
        ///// Comڵ
        ///// </summary>
        //public string ComSettings
        //{
        //    get { return _ComSettings; }
        //    set { _ComSettings = value; }
        //}
        ///// <summary>
        ///// 򿪶˿
        ///// </summary>
        //private void OpenPrinterComm()
        //{


        //    try
        //    {
        //        if (MSPrinterComm == null)
        //            throw new Exception("ն˻ӡ˿ʱ");

        //        ClosePrinterComm();

        //        MSPrinterComm.CommPort = Convert.ToInt16(Port.Replace("COM", ""));

        //        //Base.WriterLog("@MSComm.CommPort=Com" + MSPrinterComm.CommPort.ToString());

        //        /*
        //        @MSComm.Settings = "19200,N,8,1";//ͨſڲ
        //        @MSComm.InBufferSize = short.MaxValue / 2;//MSComm2ջΪ32ֽ
        //        @MSComm.OutBufferSize = 800;//MSComm2ͻΪ2ֽ
        //        @MSComm.InputMode = MSCommLib.InputModeConstants.comInputModeBinary;//ýģʽΪʽ
        //        @MSComm.EOFEnable = true;
        //        @MSComm.SThreshold = 0;//Output һδӷͻȡֽΪ1
        //        @MSComm.InBufferCount = 0;//ջ
        //        @MSComm.OutBufferCount = 0;//ͻ
        //        @MSComm.RThreshold = 1;//ý1ֽڲOnComm¼
        //        @MSComm.DTREnable = true;//??
        //        @MSComm.Handshaking = MSCommLib.HandshakeConstants.comNone;
        //        @MSComm.InputLen = 0;//ÿInputַȱʡΪ0ʾȡջȫ
        //        @MSComm.NullDiscard = false;
        //        @MSComm.PortOpen = true;//򿪴14
        //        */

        //        //@MSComm.CDHolding = false;   //ע⵱ Carrier Detect Ϊߵƽ (CDHolding = True) ҳʱʱ
        //        //MSComm ؼCommEvent Ϊ comEventCDTOCarrier Detect ʱ󣩣 OnComm ¼
        //        //ע ӦóвһʧĴرҪģһ壬Ϊ߿ʱ𣨷䣩
        //        //Carrier Detect ҲΪ Receive Line Signal Detect (RLSD)

        //        //@MSComm.DSRHolding = false;  // Data Set Ready Ϊߵƽ(On+3+15VЧDSRHolding = True) ҳʱʱ
        //        //MSComm ؼ CommEvent Ϊ comEventDSRTO׼ʱ OnComm ¼
        //        //Ϊ Data Terminal Equipment (DTE) д Data Set Ready/Data Terminal Ready ʱʮõġ
        //        //:Boolean

        //        MSPrinterComm.Settings = ComSettings;// "19200,N,8,1";//ͨſڲ,BBBB,P,D,S
        //        //BBBB ΪʣPΪżУ飬D ΪλSΪֹͣλvalue ȱʡֵǣ9600,N,8,1

        //        MSPrinterComm.Handshaking = HandshakeConstants.comNone;//Handshaking ָڲͨЭ飬ͨЭ飬
        //        //ݴӲ˿ڴ䵽ջ
        //        //һַﴮж˿ڣͨ豸ͰƵջʹԶ
        //        //ûнջҪֱӴӲȡÿһַܻܿݶʧΪ
        //        //ַٶȿԷǳ졣
        //        //Э鱣֤ڻʱݲᶪʧΪݵ˿̫ʹͨ
        //        //豸Ƶջ

        //        MSPrinterComm.InBufferSize = short.MaxValue / 16;//MSCommջΪ4KB

        //        MSPrinterComm.OutBufferSize = 1024 * 5;//MSComm2ͻΪ5KB

        //        MSPrinterComm.InputLen = 0;//ÿInputַȱʡΪ0ʾȡջȫ

        //        MSPrinterComm.InputMode = InputModeConstants.comInputModeBinary;//ýģʽΪʽ

        //        MSPrinterComm.EOFEnable = false;

        //        MSPrinterComm.SThreshold = 1; // Sthreshold Ϊ 0ȱʡֵ
        //        //ݴ¼ OnComm ¼ Sthreshold Ϊ 1仺ȫʱ
        //        //MSComm ؼ OnComm ¼ڴ仺еַС value
        //        //CommEvent Ϊ comEvSend OnComm ¼comEvSend ¼ַ Sthreshold ʱһΡ
        //        //磬 Sthreshold  5ַ 5  4 ʱcomEvSend ŷ
        //        //дûб Sthreshold ַcomEvSend ¼ᷢ

        //        MSPrinterComm.InBufferCount = 0;//ջ

        //        MSPrinterComm.OutBufferCount = 0;//ͻ

        //        MSPrinterComm.RThreshold = 1;//˵ڲ OnComm ¼֮ǰҪյַ,ý1ֽڲOnComm¼,
        //        //ַ Rthreshold Ϊ 0ȱʡֵ򲻲 OnComm ¼磬
        //        // Rthreshold Ϊ 1ջյÿһַʹ MSComm ؼ OnComm ¼ 

        //        MSPrinterComm.DTREnable = false;//Data Terminal Ready Ǽ͵ƽźţָʾڵȴմ䡣

        //        MSPrinterComm.RTSEnable = true;//ɼRequest To Send źŵӵĵƽʾݡ
        //        //(Request to send-RTS)ʾDTEDCEݣնҪʱʹźЧON״̬
        //        //MODEM͡MODEMǷҪ뷢״̬
        //        //ͣClear to send-CTSʾDCE׼ýDTEݣǶźRTSӦźš
        //        //MODEM׼ýն˴ݣǰʱʹźЧ֪ͨն˿ʼطTxDݡ

        //        MSPrinterComm.NullDiscard = false;//(*) Ϊtrue.1D564200001B6400(ضһƱ)յΪ1D5642

        //        MSPrinterComm.ParityReplace = "?";//ʺ(?)滻ǷַParityReplace Ϊһ
        //        //ַ( )żУʱַ滻Ч

        //        //:     DTE
        //        //ƽ: DCE

        //        MSPrinterComm.PortOpen = true;//򿪴14
        //        Log.Info(string.Concat("򿪴ڣ", MSPrinterComm.CommPort));
        //        //Base.WriterLog("[" + MachineObj.Name + "]" + "򿪶˿ڣ" + MSPrinterComm.CommPort);
        //    }
        //    catch (Exception ex)
        //    {
        //        Log.Warn(string.Concat("ô󡣴Ϣ",ex));
        //    }
        //}

        ///// <summary>
        ///// رն˿
        ///// </summary>
        //private void ClosePrinterComm()
        //{
        //    try
        //    {
        //        if (MSPrinterComm != null && MSPrinterComm.PortOpen)
        //            MSPrinterComm.PortOpen = false;//رն˿
        //    }
        //    catch(Exception exception)
        //    {
        //        Log.Info(string.Concat("رն˿쳣Ϣ",exception));
        //    }
        //}

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <returns></returns>
        public override CaptureDataInfo Output()
        {
            int maxWaitTime = MachineInfo.MachineConfigEntity.C_PrintWaitTime;
            //Ʊ10ӣдƱ67ӲŷƱ
            //if (LotMachine.CurrentTicket != null && LotMachine.CurrentTicket.L_Money >= 500)
            //{
            //    maxWaitTime = 10 * 60 * 1000;
            //}
            int waitTime = 0;
            while (Status == VirtualPrinterStatus.Running && waitTime < maxWaitTime && oneTicketData == null)
            {
                Thread.Sleep(30);
                waitTime += 30;
                if (waitTime % 900 == 0)
                {
                    Log.Info(string.Concat("ȡƱݵȴ", waitTime, ""));
                }
                if (_forceStop)
                {
                    break;
                }
            }
            Log.Info(string.Concat("ȡƱݵȴ", waitTime, ""));
            CaptureDataInfo captureDataInfo;
            if (oneTicketData != null)
            {
                captureDataInfo = new CaptureDataInfo(oneTicketData);
            }
            else
            {
                byte[] data = new byte[_receivedBuffer.Count];
                _receivedBuffer.CopyTo(data);
                captureDataInfo = new CaptureDataInfo(data);
                if (data.Length > 0)
                {
                    SaveLastFile(captureDataInfo);
                }
            }
            return captureDataInfo;
        }
        private byte[] oneTicketData = new byte[] { };

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <returns></returns>
        public override CaptureDataInfo ReOutput()
        {
            CaptureDataInfo captureDataInfo;
            if (oneTicketData != null)
            {
                captureDataInfo = new CaptureDataInfo(oneTicketData);
            }
            else
            {
                byte[] data = new byte[_receivedBuffer.Count];
                _receivedBuffer.CopyTo(data);
                captureDataInfo = new CaptureDataInfo(data);
                if (data.Length > 0)
                {
                    SaveLastFile(captureDataInfo);
                }
            }
            return captureDataInfo;
        }

        /// <summary>
        /// ǿֹͣǰƱ
        /// </summary>
        public override void ForceStop()
        {
            Log.Info("ǿֹͣȴƱ");
            //_oneTicketReceived = true;
            _forceStop = true;
        }

        /// <summary>
        /// սջ
        /// </summary>
        public override void ClearBuffer()
        {
            _oneTicketReceived = false;
            oneTicketData = null;
            _forceStop = false;

            _receivedBuffer.Clear();
            _receivedStringBuffer.Length = 0;
        }

        private void ClearBufferAfterOneTicket()
        {
            _oneTicketReceived = false;
            _receivedBuffer.Clear();
            _receivedStringBuffer.Length = 0;
            Log.Debug("յһƱսݻ");
        }

        #endregion

        #region 
        //public FileStream AlldataStream = null;
        private bool _oneTicketReceived = false;
        private bool _forceStop = false;
        //ջ
        private List<byte> _receivedBuffer = new List<byte>();
        private StringBuilder _receivedStringBuffer = new StringBuilder();

        private DateTime _lastTicketTime = DateTime.Now;
        private const string EndString = "1D 56 42";//01 1D 56 42 00
        private string[] EndStringArr = new string[] { "1D 56 42", "01 1D 56 42 00", "1D 56 42 00", "55 AA 01 02 1D 1F", "55 AA 01 07 1D 99 42 45 92 9A 41 55 AA 01 07 1D 99 42 45 92 9A 41", "66 66 66 06 18 E6 60 E0 66 66 66 06 18 E6 60 E0" };
        /// <summary>
        /// ִݽ
        /// </summary>
        private void DoTask()
        {
            try
            {
                int toalwait = 0;
                while (Status == VirtualPrinterStatus.Running)
                {
                    toalwait += 100;
                    Thread.Sleep(100);
                    int bytesToRead=0;
                    if (PrinterPort.IsOpen)
                    {
                        bytesToRead = PrinterPort.BytesToRead;
                    }
                    if (bytesToRead > 0)
                    {
                        byte[] readBytes = new byte[bytesToRead];
                        PrinterPort.Read(readBytes, 0, readBytes.Length);
                        _receivedBuffer.AddRange(readBytes);
                        //if (AlldataStream != null)
                        //{
                        //    AlldataStream.Write(readBytes, 0, readBytes.Length);
                        //    AlldataStream.Flush();
                        //}
                        string tmpStr = HexString.ByteToString(readBytes) + " ";
                        _receivedStringBuffer.Append(tmpStr);
                        //Log.Debug(string.Concat("ӲƱյݣ", tmpStr, "ֽ", readBytes.Length));
                        string strReceived = _receivedStringBuffer.ToString();
                        Log.Debug(string.Concat("ӲƱֽ", readBytes.Length, " յַ", strReceived));

                        bool isreply = false;
                        if (strReceived.EndsWith("10 04 01 10 04 02 10 04 03 10 04 04 "))
                        {
                            isreply = true;
                            strReceived = "";
                            _receivedBuffer.Clear();
                            _receivedStringBuffer.Remove(0, _receivedStringBuffer.Length);
                        }
                        if (strReceived.StartsWith("1D 4C 40 00 1D 57 00 03"))
                        {
                            isreply = true;
                            _receivedBuffer.RemoveRange(0, 8);
                            _receivedStringBuffer.Remove(0, 24);
                        }
                        

                        if (isreply)
                        {
                            Write("16 12 12 12");    //ظʼ
                        }
                        else
                        {
                            //ȡƱݣжǷյһƱ
                            strReceived = _receivedStringBuffer.ToString();
                            //if (!_oneTicketReceived && strReceived.Length > 900 && strReceived.IndexOf(EndString, 200) != -1)

                            bool isend = false;
                            string strReceived_temp = strReceived.TrimEnd();
                            foreach (string endstring in EndStringArr)
                            {
                                if (strReceived_temp.EndsWith(endstring))
                                {
                                    isend = true;
                                    break;
                                }
                            }

                            if (!_oneTicketReceived && isend)                            
                            {
                                Log.Info(string.Concat("ӲƱյһƱֽ", _receivedBuffer.Count, "ַܳȣ", strReceived.Length));
                                _oneTicketReceived = true;

                                _lastTicketTime = DateTime.Now;
                                oneTicketData = new byte[_receivedBuffer.Count];
                                _receivedBuffer.CopyTo(oneTicketData);
                                ClearBufferAfterOneTicket();

                                SaveLastFile(oneTicketData);

                                try
                                {
                                    if (MachineInfo.M_AllowPaperout)
                                    {
                                        PrinterPort.Write(oneTicketData, 0, oneTicketData.Length);
                                    }
                                }
                                catch (Exception exception)
                                {
                                    Log.Info(string.Concat("ӡ", exception.ToString()));
                                }

                                //Ʊ
                                CaptureDataInfo captureDataInfo = new CaptureDataInfo(oneTicketData);
                                string input = captureDataInfo.CaptureDataString;

                                int tmpEnd = input.IndexOf("-------------------");
                                if (tmpEnd < 0)
                                    continue;
                                string strPlayCodetype = input.Substring(0, tmpEnd);

                                L_LotTicketEntity ticketEntity = new L_LotTicketEntity();
                                if (strPlayCodetype.IndexOf("") > 0)
                                {
                                    ticketEntity.LotId = (int)Lottype.Jz ;
                                    if (strPlayCodetype.IndexOf("Ϲ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JzHHGG;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JzHhgg;
                                    }
                                    else if (strPlayCodetype.IndexOf("ʤƽ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JzSPF;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JzSpf;
                                    }
                                    else if (strPlayCodetype.IndexOf("ʤƽ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JzRQSPF;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JzSpfn;
                                    }
                                    else if (strPlayCodetype.IndexOf("ȷ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JzBF;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JzBf;
                                    }
                                    else if (strPlayCodetype.IndexOf("ȫʤƽ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JzBQC;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JzBqc;
                                    }
                                    else if (strPlayCodetype.IndexOf("ܽ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JzJQS;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JzZjq;
                                    }
                                }
                                else if (strPlayCodetype.IndexOf("") > 0)
                                {
                                    ticketEntity.LotId = (int)Lottype.Jl;
                                    if (strPlayCodetype.IndexOf("Ϲ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JlHHGG;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JlHhgg;
                                    }
                                    else if (strPlayCodetype.IndexOf("С") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JlDXF;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JlDxf;
                                    }
                                    else if (strPlayCodetype.IndexOf("÷ʤ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JlRFSF;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JlRfsf;
                                    }
                                    else if (strPlayCodetype.IndexOf("ʤֲ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JlSFC;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JlSfc;
                                    }
                                    else if (strPlayCodetype.IndexOf("ʤ") > 0)
                                    {
                                        ticketEntity.L_PlayId = (int)Playtype.JlSF;
                                        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JlSf;
                                    }
                                }
                                //else if (strPlayCodetype.IndexOf("") > 0)
                                //{
                                //    ticketEntity.LotId = (int)Lottype.Jm;
                                //    if (strPlayCodetype.IndexOf("-ھ") > 0)
                                //    {
                                //        ticketEntity.L_PlayId = (int)Playtype.JmGj;
                                //        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JmGj;
                                //    }
                                //    else if (strPlayCodetype.IndexOf("-Ǿ") > 0)
                                //    {
                                //        ticketEntity.L_PlayId = (int)Playtype.JmGyj;
                                //        ticketEntity.MacModeId = (int)TjJingCaiV1ModeType.JmGyj;
                                //    }
                                //}
                                //else  //ǾʵƱ
                                //{
                                   
                                //}
                                else if (strPlayCodetype.Contains("ʱα"))  //ʱα
                                { 
                                    ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacReport.MacReportService service = new ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacReport.MacReportService();
                                    DecodeMachineReport decodeMachineReport = new DecodeMachineReport();
                                    decodeMachineReport.InputData = captureDataInfo;
                                    service.DecodeMachineReportReport(null, decodeMachineReport);

                                    if (decodeMachineReport.DecodeSuccess)
                                    {
                                        A10005UploadMachineSale pack = new A10005UploadMachineSale();
                                        pack.AgentId = MachineInfo.M_Number;
                                        pack.Salt = LotMachine.MachineInfo.M_Salt;
                                        pack.SaleMoney = decodeMachineReport.MachineReportEntity.R_SaleMoney;
                                        pack.SaleNum = decodeMachineReport.MachineReportEntity.R_SaleTicket;
                                        pack.EncashMoney = decodeMachineReport.MachineReportEntity.R_EncashMoney;
                                        pack.EncashNum = decodeMachineReport.MachineReportEntity.R_EncashTicket;
                                        pack.ReturnMoney = decodeMachineReport.MachineReportEntity.R_ReturnMoney;
                                        pack.ReturnNum = decodeMachineReport.MachineReportEntity.R_ReturnTicket;
                                        pack.QueryTime = decodeMachineReport.MachineReportEntity.R_QueryTime.ToString("yyyyMMddHHmmss");
                                        pack.From = decodeMachineReport.MachineReportEntity.R_StartTime.ToString("yyyyMMdd");
                                        pack.To = decodeMachineReport.MachineReportEntity.R_EndTime.ToString("yyyyMMdd");
                                        if (pack.From != pack.To)
                                        {
                                            continue;
                                        }
                                        pack.Type = 1;
                                        pack.TypeName = pack.From;
                                        pack.Prntext = decodeMachineReport.MachineReportEntity.R_PrnText;

                                        A10005UploadMachineSaleRet packRet = PackManager.Instance.Send(pack) as A10005UploadMachineSaleRet;
                                        if (packRet.Code <= 0)
                                        {
                                            LotMachine.Log.Warn("ϴ챨ʧܣ" + packRet.Message);
                                        }
                                        else
                                        {
                                            LotMachine.Log.Info("ϴ챨ɹ" + packRet.AgentId);
                                        }

                                    }
                                    else
                                    {
                                        LotMachine.Log.Warn(string.Concat("챨ʧܡϢ", decodeMachineReport.ErrorMessage));
                                    }
                                }
                                else if (strPlayCodetype.Contains("ɿ"))  //ɿ
                                {
                                    //ɿ
                                    ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacReport.MacReportService service = new ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacReport.MacReportService();
                                    DecodeMachinePayMoneyReport decodePrintData = new DecodeMachinePayMoneyReport();
                                    decodePrintData.InputData = captureDataInfo;
                                    service.DecodeMachinePayMoneyReport(null, decodePrintData);

                                    if (decodePrintData.DecodeSuccess)
                                    {
                                        A10006UploadMachineBalance pack = new A10006UploadMachineBalance();
                                        pack.AgentId = MachineInfo.M_Number;
                                        pack.Salt = LotMachine.MachineInfo.M_Salt;

                                        pack.Balance = decodePrintData.MachinePayMoneyReportEntity.R_Balance;
                                        pack.QueryTime = decodePrintData.MachinePayMoneyReportEntity.R_QueryTime.ToString("yyyyMMddHHmmss");
                                        pack.From = decodePrintData.MachinePayMoneyReportEntity.R_QueryTime.ToString("yyyyMMdd");
                                        pack.To = decodePrintData.MachinePayMoneyReportEntity.R_QueryTime.ToString("yyyyMMdd");
                                        pack.Type = 1;
                                        pack.TypeName = pack.From;   //ʱֻ챨Ժ±˵
                                        pack.Prntext = decodePrintData.MachinePayMoneyReportEntity.R_PrnText;

                                        A10006UploadMachineBalanceRet packRet = PackManager.Instance.Send(pack) as A10006UploadMachineBalanceRet;
                                        if (packRet.Code <= 0)
                                        {
                                            LotMachine.Log.Warn("ϴɿеʧܣ" + packRet.Code.ToString() + " " + packRet.Message);
                                        }
                                        else 
                                        {
                                            LotMachine.Log.Info("ϴɿеɹ" + packRet.AgentId);
                                        }


                                        A10007UploadMachinePay pack1 = new A10007UploadMachinePay();
                                        pack1.AgentId = MachineInfo.M_Number;
                                        pack1.Salt = LotMachine.MachineInfo.M_Salt;

                                        pack1.QueryTime = decodePrintData.MachinePayMoneyReportEntity.R_QueryTime;
                                        foreach (PayMoneyDataItem item in decodePrintData.MachinePayMoneyReportEntity.R_DataList)
                                        {
                                            pack1.PaymentList.Add(new UploadMachinePayItem(item.PayType, item.PayMoney, item.PayTime));
                                        }

                                        A10007UploadMachinePayRet packRet1 = PackManager.Instance.Send(pack1) as A10007UploadMachinePayRet;
                                        if (packRet1.Code <= 0)
                                        {
                                            LotMachine.Log.Warn("ϴɿеĽɿ¼ʧܣ" + packRet1.Code.ToString() + " " + packRet1.Message);
                                        }
                                        else
                                        {
                                            LotMachine.Log.Info("ϴɿеĽɿ¼ɹ" + packRet.AgentId);
                                        }
                                    }
                                    else
                                    {
                                        LotMachine.Log.Warn(string.Concat("ɿʧܡϢ", decodePrintData.ErrorMessage));
                                    }
                                }


                                //ϴƱ
                                if (ticketEntity.LotId == (int)Lottype.Jz || ticketEntity.LotId == (int)Lottype.Jl)
                                {

                                    DecodePrintData decodePrintData = new DecodePrintData();
                                    decodePrintData.InputData = captureDataInfo;
                                    MacLotPlayModeServiceFactory modeServiceFactory = new MacLotPlayModeServiceFactory();
                                    IMacLotPlayModeService modeService = modeServiceFactory.GetLotPlayService(ticketEntity.MacModeId);
                                    modeService.DecodeData(ticketEntity, MachineInfo, decodePrintData);

                                    if (decodePrintData.DecodeSuccess)
                                    {
                                        try
                                        {

                                            //֪ͨƱ
                                            A10002NotifyTicket pack = new A10002NotifyTicket();
                                            pack.AgentId = MachineInfo.M_Number;
                                            pack.Salt = LotMachine.MachineInfo.M_Salt;
                                            ticketEntity.L_TicketCode = decodePrintData.L_PrintTicketEntity.P_TicketCode;
                                            ticketEntity.L_Password = decodePrintData.L_PrintTicketEntity.P_Password;
                                            ticketEntity.L_CodeRate = decodePrintData.L_PrintTicketEntity.L_CodeRate;
                                            ticketEntity.L_CodeReference = decodePrintData.L_PrintTicketEntity.L_CodeReference;   //
                                            ticketEntity.L_SucTime = decodePrintData.L_PrintTicketEntity.P_SucTime;
                                            ticketEntity.L_PrnText = decodePrintData.L_PrintTicketEntity.P_PrnText;
                                            ticketEntity.L_Status = (int)TicketStatus.Suc;
                                            ticketEntity.L_LimitType = 0;
                                            //
                                            ticketEntity.L_Code = decodePrintData.L_PrintTicketEntity.P_Code;
                                            ticketEntity.L_Money = decodePrintData.L_PrintTicketEntity.P_Money;
                                            ticketEntity.L_Mutiple = decodePrintData.L_PrintTicketEntity.P_Mutiple;
                                            ticketEntity.L_CodeType = decodePrintData.L_PrintTicketEntity.L_CodeType;
                                            pack.Ticket = ticketEntity;

                                            int retry = 0;
                                            int retCode = 0;
                                            while (retry < 3)
                                            {
                                                A10002NotifyTicketRet packRet = PackManager.Instance.Send(pack) as A10002NotifyTicketRet;
                                                if (packRet.Code > 0)
                                                {
                                                    retCode = packRet.Code;
                                                    break;
                                                }

                                                retry++;
                                                if (retry == 3)
                                                {
                                                    LotMachine.Log.Warn("ʾ볢Ե֪ͨ");
                                                    throw new Exception("Ʊ֪ͨʧܣԶ3Σ" + packRet.Code.ToString() + " " + packRet.Message);
                                                }

                                                Thread.Sleep(retry * 1000);
                                            }

                                            if (retCode == 300)
                                            {
                                                //ɾlastĿ¼һļ
                                                LotMachine.VirtualPrinter.DeleteLastFile();

                                                LotMachine.Log.Info(string.Concat("Ʊ֪ͨɹ", ticketEntity.L_TicketSn, " ֣", ticketEntity.L_LotName, ticketEntity.LotId, "淨", ticketEntity.L_PlayName, ticketEntity.L_PlayId, "", ticketEntity.L_Mutiple, "", ticketEntity.L_Money));
                                            }
                                            else if (retCode == 304)
                                            {
                                                LotMachine.Log.Info("дһŴƱ!");
                                            }
                                        }
                                        catch (Exception exception)
                                        {
                                            LotMachine.Log.Warn(string.Concat("Ʊ֪ͨʧܡˮţ", ticketEntity.L_TicketSn, " Ʊţ", ticketEntity.L_TicketCode, " 룺", ticketEntity.L_Password));

                                        }
                                    }
                                    else
                                    {
                                        LotMachine.Log.Warn(string.Concat("Ʊʧܡˮţ", ticketEntity.L_TicketSn, " Ϣ", decodePrintData.ErrorMessage));
                                    }
                                }
                                
                            }
                            
                        }
                    }
                    if (toalwait == 30000)
                    {
                        toalwait = 0;
                        Log.Info("ӡ");
                    }

                }
                try
                {
                    PrinterPort.Close();
                    PrinterPort.Dispose();
                }
                finally
                {
                    PrinterPort = null;
                }
                Status = VirtualPrinterStatus.Stopped;
                Log.Info(string.Concat("ӡֹͣ"));

            }
            catch (Exception ex)
            {
                Log.Warn(string.Concat("Ʊ ", this.MachineInfo.M_Number, " ӡ쳣ֹͣƱ׳"));

                //Log.Warn(string.Concat("Ʊ ", this.MachineInfo.M_Number, " 쳣", ex.ToString()));
                //if (ex.Message.Contains("ڱر"))
                //{
                //    Log.Warn("ʾѾץȡƱݣ´ƱƱ˵ûƱֹͣƱ");
                //}
            }
            //finally
            //{
            //    if (AlldataStream != null)
            //    {
            //        AlldataStream.Close();
            //        AlldataStream.Dispose();
            //    }
            //}

        }

        private void Write(string strWrite)
        {

            byte[] data = StringToBytes(strWrite);
            PrinterPort.Write(data, 0, data.Length);
            Log.Info("Write:" + strWrite);
            /*
            for (int j = 0; j < blist.Length; j++)
            {
                if (1 > 1)
                    Thread.Sleep(1);
                com1.Write(blist, j, 1);
            }
            */
        }

        public static byte[] StringToBytes(string str)
        {
            string[] ByteStrings;
            byte[] result;
            try
            {
                ByteStrings = str.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);

                result = new byte[ByteStrings.Length];
                for (int i = 0; i < ByteStrings.Length; i++)
                {
                    result[i] = Convert.ToByte(ByteStrings[i], 16);
                }
            }
            catch
            {
                result = new byte[1] { 0 };
            }
            return result;
        }

        public static string BytesToString(byte[] data)
        {
            string result = "";
            if (data != null)
            {
                StringBuilder sb = new StringBuilder();
                for (int i = 0; i < data.Length; i++)
                {
                    sb.Append(data[i].ToString("X2")).Append(" ");
                }
                result = sb.ToString();
            }
            return result;
        }
        #endregion
    }
}
